//             TECHNOLOGICAL ARTS
//              +1(416) 963-8996 
//	        www.technologicalarts.ca

#include <hidef.h>      	/* common defines and macros */
#include <mc9s12dp512.h>     /* derivative information */
#include <PORT.h>

#define Set 1
#define Reset 0


//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
// This subroutine will initialise the IIC
//***************************************************
void IIC_Initialization(void)
//***************************************************
{
IBFD = 0x23; // frequency divider register: Bus = 8MHz => SCL = 91kHz;
IBAD = 0x00; // slave address of this module;
IBCR = 0x80; // enable I2C module and No interrupts;
}


//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
void IIC_test_flag(void)
{
while (!IBSR_IBIF); 		// wait until IBIF;
IBSR_IBIF=Set; 				  // clear the interrupt event flag;
while(IBSR_RXAK); 			// check for RXAK;
}


// This subroutine converts character into Packed BCD
char HEX_TO_BCD(char DATA)
{
	char BCD;
	BCD=0x00;
	while(DATA>=0x0A)
	{
		DATA=DATA-0x0A;
		BCD++;	
	}
	BCD=BCD<<4;
	DATA|=BCD;
	return(DATA);
	
}

// This subroutine converts Packed BCD into Character
char BCD_TO_HEX(char DATA1)
{
char UN,LN;
 UN=DATA1&0xF0;
 UN=UN>>4;
 LN=DATA1&0x0F;
 
 while(UN>0)
 {
 LN=LN+0x0A;
 UN--;
 }
 return(LN);
 }
 
 
 
//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
// Write PAGE into EEPROM 24C64. This subroutine require EEPROM device address, 
// starting Location MSB Address and LSB Location.
//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
/////////////////////////////////////////////////////
//^%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
void IIC_write(unsigned char EEPROM_ADD,unsigned char ADD,unsigned char *Data, int pagelength)
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
{ 
int i;   
IBCR_TXAK = Reset; 			// TXAK = 0;
IBCR_TX_RX=Set; 			  // RX/TX = 1; MS/SL = 1; TXAK = 0;
IBCR_MS_SL=Set;				  // And generate START condition;

IBDR = EEPROM_ADD; 			// Address the slave and set up for master transmit;
IIC_test_flag();
IBDR = ADD;					    // Send high byte of the word address;
IIC_test_flag();


for(i=0;i<pagelength;i++)	// write page to memory
{
IBDR =Data[i] ;
IIC_test_flag();
}
IBCR_MS_SL = Reset;  		// generate STOP condition;
}



